#ifndef __WINE_MIXEDCRT_STRING_H
#define __WINE_MIXEDCRT_STRING_H

/*
 * Embrace
 */

#ifdef __GNUC__
#include_next <string.h>
#else
#include "nativecrt/string.h"
#endif



/*
 * Extend
 */

#define _memccpy(dst,src,c,n)      memccpy(dst,src,c,n)
/* _memicmp */
/* memicmp */
#define _strcmpi(str1,str2)        strcasecmp(str1,str2)
#define strcmpi(str1,str2)         strcasecmp(str1,str2)
#define _stricmp(str1,str2)        strcasecmp(str1,str2)
#define stricmp(str1,str2)         strcasecmp(str1,str2)
#define _stricoll(str1,str2)       strcasecmp(str1,str2)
#define _strncoll(str1,str2,n)     strncmp(str1,str2,n)
#define _strnicoll(str1,str2,n)    strncasecmp(str1,str2,n)
#define _strdup(str)               strdup(str)
#define _strerror(errnum)          strerror(errnum)
#define _strlwr(str)               ({char* c_;for (c_=str;*c_!='\0';c_++) *c_=tolower(*c_);str;})
#define strlwr(str)                _strlwr(str)
#define _strnicmp(str1,str2,n)     strncasecmp(str1,str2,n)
#define strnicmp(str1,str2,n)      strncasecmp(str1,str2,n)
/* _strnset */
/* strnset */
#define _strrev(str)               ({char* s_=str;char* e_=s_+strlen(s_)-1;while (s_<e_) {char t_=*s_;*s_++=*e_;*e_--=t_;};str;})
#define strrev(str)                _strrev(str)
#define _strset(str,c)             memset(str,c,strlen(str))
#define strset(str,c)              memset(str,c,strlen(str))
#define _strupr(str)               ({char* c_;for (c_=str;*c_!='\0';c_++) *c_=toupper(*c_);str;})
#define strupr(str)                _strupr(str)

#define _wcsdup(wstr)              wcsdup(wstr)
#define _wcsicmp(str1,str2)        wcscasecmp(str1,str2)
#define wcsicmp(str1,str2)         wcscasecmp(str1,str2)
#define _wcsnicmp(str1,str2,n)     wcsncasecmp(str1,str2,n)
#define wcsnicmp(str1,str2,n)      wcsncasecmp(str1,str2,n)
/* _wcsnset */
/* wcsnset */
/* _wcsrev */
/* wcsrev */
/* _wcsset */
/* wcsset */
/* _wcslwr */
/* wcslwr */
/* _wcsupr */
/* wcsupr */
/* wcsxfrm */
#define wcscoll(str1,str2)         wcscmp(str1,str2)
#define _wcsicoll(str1,str2)       wcscasecmp(str1,str2)
#define wcsicoll(str1,str2)        wcscasecmp(str1,str2)
#define _wcsncoll(str1,str2,n)     wcsncmp(str1,str2,n)
#define _wcsnicoll(str1,str2,n)    wcsncasecmp(str1,str2,n)


#endif /* __WINE_MIXEDCRT_STRING_H */
