#ifndef __WINE_MIXEDCRT_STDIO_H
#define __WINE_MIXEDCRT_STDIO_H

/*
 * Embrace
 */

#ifdef __GNUC__
#include_next <stdio.h>
#else
#include "nativecrt/stdio.h"
#endif



/*
 * Extend
 */

#define _fcloseall()               fcloseall()
#define _fdopen(fd,mode)           fdopen(fd,mode)
#define _fgetchar()                getchar()
#define _fileno(stream)            fileno(stream)
#define _flushall()                sync()
#define _fputchar(c)               putchar(c)
/* getmaxstdio */
#define _getw(stream)              getw(stream)
#define _pclose(stream)            pclose(stream)
#define _popen(command,type)       popen(command,type)
#define _putw(c,stream)            putw(c,stream)
/* _rmtmp */
/* _setmaxstdio */
#define _snprintf                  snprintf
#define _tempnam(dir,prefix)       tempnam(dir,prefix)
#ifndef _unlink
#define _unlink(pathname)          unlink(pathname)
#endif
#define _vsnprintf(str,sz,fmt,l)   vsnprintf(str,sz,fmt,l)


#endif /* __WINE_MIXEDCRT_STDIO_H */
